<?php
////////////////////////////////////////////////////////////////////////
// SMSapi NOTIFICATION FUNCTIONS
////////////////////////////////////////////////////////////////////////

function smsapi_component_clickatell_send($args){
	$settings_raw=get_option("smsapi_component_options");

	if($settings_raw=="") {
		$settings=array();
	}
	else {
		$settings=unserialize($settings_raw);
	}

	$apiid=grab_array_var($settings,"ca_apiid");
	$user=grab_array_var($settings,"ca_user");
	$pass=grab_array_var($settings,"ca_pass");
	$from=grab_array_var($settings,"ca_from");

	$number=grab_array_var($args,"number");
	$message=grab_array_var($args,"message");
	
	// bail if empty number or message
	if($number=="" || $message=="")
		return 1;

	// construct the URL to give to Twilio
	$url="https://api.clickatell.com/http/sendmsg?";
	$url .= "api_id=" . rawurlencode($apiid);
	$url .= "&user=" . rawurlencode($user);
	$url .= "&password=" . rawurlencode($pass);
	if (strlen($from)) {
		$url .= "&from=" . rawurlencode($from);
	}
	$url .= "&to=" . rawurlencode($number);
	$url .= "&text=" . rawurlencode($message);

	$options['method'] = 'post';
	$options['timeout'] = 10;
	$options['return_info'] = true;

	// send the request
	$r = load_url($url, $options);

	if ($r[info][http_code] == '200') {
		if (ereg('^ERR:', $r[body])) {
			$result['success'] = 0;
			$result['message'] = str_replace("\n", "<br />", $r[body]);
		}
		else {
			$result['success'] = 1;
		}
	}
	else {
		$result['success'] = 0;
		$result['message'] = str_replace("\n", "<br />", $r[body]);
	}

	return $result;
}

?>
