<?php
////////////////////////////////////////////////////////////////////////
// SMSapi NOTIFICATION FUNCTIONS
////////////////////////////////////////////////////////////////////////

function smsapi_component_twilio_send($args){
	$settings_raw=get_option("smsapi_component_options");

	if($settings_raw=="") {
		$settings=array();
	}
	else {
		$settings=unserialize($settings_raw);
	}

	$sid=grab_array_var($settings,"tw_sid");
	$token=grab_array_var($settings,"tw_token");
	$from=grab_array_var($settings,"tw_from");

	$number=grab_array_var($args,"number");
	$message=grab_array_var($args,"message");
	
	// bail if empty number or message
	if($number=="" || $message=="")
		return 1;

	// construct the URL to give to Twilio
	$url="https://$sid:$token@api.twilio.com/2010-04-01/Accounts/$sid/SMS/Messages?";
	$url .= "From=" . rawurlencode($from);
	$url .= "&To=" . rawurlencode($number);
	$url .= "&Body=" . rawurlencode($message);

	$options['method'] = 'post';
	$options['timeout'] = 15;
	$options['return_info'] = true;

	// send the request
	$r = load_url($url, $options);

	if ($r[info][http_code] == '0') {
		$result['success'] = 0;
		$result['message'] = 'Request timeout';
	}
	else if ($r[info][http_code] == '201') {
		$result['success'] = 1;
	}
	else {
		$result['success'] = 0;
		$result['message'] = str_replace("\n", "<br />", $r[body]);
	}

	return $result;
}

?>
